var baseurl = (location.pathname.indexOf("/pbs/") != -1 ? "/pbs" : (location.pathname.indexOf("/pbs_war/") != -1 ? "/pbs_war" : ""))
function listenExcelLoading() {
	//定时监听
	//打开加载中遮罩
	$(".export-loading-img").show();
	// 导出按钮禁用
	$(".d-export-btn").css("pointer-events","none");
	$("#txtendflag").val('');
	getendflag();
	var loop = setInterval(function() {
		if ($("#txtendflag").val() == "1") {
			clearInterval(loop);//停止定时任务
			$("#txtendflag").val('');
			$(".export-loading-img").hide();//关闭加载中遮罩
			// 导出按钮释放
			$(".d-export-btn").css("pointer-events", "auto");
		} else {
			getendflag();
		}
	}, 1000);//单位毫秒  注意：如果导出页面很慢时，建议循环时间段稍长一点
}

function getendflag() {
	//请求session标记位
	$.ajax({
		type : 'post',
		url : baseurl+"/pat/searchExcelExportEndflag.html",
		dataType : 'json',
		cache: false,
		success : function(data) {
			$("#txtendflag").val(data);
		},
		error : function(error) {

		}
	});
}

//导出（所有）选中搜索结果
function exportAllSelected() {
	$.ajax({
		url: baseurl+"/pat/checkExportRole.html",
		type: 'get',
		cache: false,
		success: function (data) {
			if (data == "1") { // 可执行导出操作
				// 获取选中项的值
				var obj = document.getElementsByName('patentid');
				var curPatentId = []
				for(var i = 0; i < obj.length; i++) {
					if(obj[i].checked) curPatentId.push(obj[i].value)
				}
				// 提示选中不能为空
				if (curPatentId.length === 0) {
					dialog.tipsPop('', '提示', '请选择专利！')
					setTimeout(function() {
						$(".ui-dialog-close").click()
					},1000);
					return
				}
				// 选中项不为空时（转为字符串）
				curPatentId = curPatentId.join()
				var iframe = document.getElementById('brandExcelFileFrame');
				iframe.src = baseurl+"/pat/exportSearchIdsResult.html?patentIds=" + curPatentId; // 下载资源
				listenExcelLoading();
			} else if (data == "2") {
				$(".viptip-title").html("抱歉，您暂时无法使用导出功能！");
				$(".viptip-content").html("龙图腾高级会员享有导出清单的权益，您可以选择以下方式成为高级会员：");
				$(".exportTipModalBtn").click();
			} else {
				// $("#myForm").attr("action", baseurl+"/loginForm.html");
				// $("#myForm").submit();
				isLoginModalFlag()
			}
		}
	});
}

// 导出搜索结果
function exportList(){
	$.ajax({
		url: baseurl+"/pat/checkExportRole.html",
		type: 'get',
		cache : false,
		success: function(data) {
			if (data == "1") {
				var startPage = page;
				var exportLimit = pageSize;
				sureExportList(startPage, exportLimit);
			} else if (data == "2") {
				$(".viptip-title").html("抱歉，您暂时无法使用导出功能！");
				$(".viptip-content").html("龙图腾高级会员享有导出清单的权益，您可以选择以下方式成为高级会员：");
				$(".exportTipModalBtn").click();
			} else {
				// $("#myForm").attr("action", baseurl+"/loginForm.html");
				// $("#myForm").submit();
				isLoginModalFlag()
			}
		}
	});
}

//整理当前的搜索条件
function processSearchCondition() {
	var patentRemark=[];
	if(patentRemarkColumns.length==0){
		patentRemark=exportRemarkColumns;
	}else{
		patentRemark=patentRemarkColumns;
	}

	var keywordTemp="";
	if(keyword !=null && keyword !=""){
		keywordTemp=keyword;
	}else{
		keywordTemp=$("#keywordInit").val();
	}
	var epriceBegin = priceBeginDou || priceBegin;
	var epriceEnd = priceEndDou || priceEnd;
	var exportSearchCondition="keyword="+encodeURIComponent(keywordTemp)+"&topKeyword="+encodeURIComponent(topKeyword)+"&status="+status_s+"&patentTypeAndSells="+patentTypeAndSells
			+"&patentRemarkColumns="+encodeURIComponent(patentRemark)+"&patentRange="+patentRange+"&userFollowFlag="+userFollowFlag+"&patentId="+searchPatentId
			+"&bargain="+bargain+"&priceBegin="+epriceBegin+"&priceEnd="+epriceEnd
			+"&addDateSort="+addDateSort+"&priceSort="+priceSort+"&newestAddDateSort="+newestAddDateSort
			+"&homeIndexRemarkColumns="+encodeURIComponent(homeIndexRemarkColumns)
			+"&appPerson=" + encodeURIComponent(proposerValue)
			+"&addDateBegin="+theAddDateBegin+"&addDateEnd="+theAddDateEnd
			+"&grantDateBegin="+theGrantDateBegin+"&grantDateEnd="+theGrantDateEnd
			+"&appDateBegin="+theAppDateBegin+"&appDateEnd="+theAppDateEnd
			+"&feeDateBegin="+theFeeDateBegin+"&feeDateEnd="+theFeeDateEnd
			+"&absKeyword="+absKeyword;
	return exportSearchCondition;
}

// 确认导出
function sureExportList(startPage, exportLimit) {
	var exportSearchCondition = processSearchCondition();
	var iframe = document.getElementById('brandExcelFileFrame');
	iframe.src = baseurl+"/pat/exportSearchResult.html?" + exportSearchCondition+"&limit="+exportLimit+"&page="+startPage;
	exportRemarkColumns=[];
	listenExcelLoading();
}

// 导出精品专利
function exportAllSelf() {
	$.ajax({
		url: baseurl+"/pat/checkExportRole.html",
		type: 'get',
		cache : false,
		success: function(data) {
			if (data == "1") {
				var exportSearchCondition="keyword=&status=&patentTypeAndSells=&patentRemarkColumns=&bargain=0&priceBegin=&priceEnd=&addDateSort=&priceSort=";
				var iframe = document.getElementById('brandExcelFileFrame');
				iframe.src = baseurl+"/pat/exportSelfPatent.html";
				listenExcelLoading();
			} else if (data == "2") {
				$(".viptip-title").html("抱歉，您暂时无法使用导出功能！");
				$(".viptip-content").html("龙图腾高级会员享有导出清单的权益，您可以选择以下方式成为高级会员：");
				$(".exportTipModalBtn").click();
			} else {
				// $("#myForm").attr("action", baseurl+"/loginForm.html");
				// $("#myForm").submit();
				isLoginModalFlag()
			}
		}
	});
}

// 导出会员特惠专利
function exportAllBoutiquePatents() {
	$.ajax({
		url: baseurl+"/pat/checkExportRole.html",
		type: 'get',
		cache : false,
		success: function(data) {
			if (data == "1") {
				var iframe = document.getElementById('brandExcelFileFrame');
				iframe.src = baseurl+"/pat/exportBoutiquePatents.html";
				listenExcelLoading();
			} else if (data == "2") {
				$(".viptip-title").html("抱歉，您暂时无法使用导出功能！");
				$(".viptip-content").html("龙图腾高级会员享有导出清单的权益，您可以选择以下方式成为高级会员：");
				$(".exportTipModalBtn").click();
			} else {
				// $("#myForm").attr("action", baseurl+"/loginForm.html");
				// $("#myForm").submit();
				isLoginModalFlag()
			}
		}
	});
}


// 导出特价专利
function exportfAllSpecial() {
	$.ajax({
		url: baseurl+"/pat/checkExportRole.html",
		type: 'get',
		cache : false,
		success: function(data) {
			if (data == "1") {
				var iframe = document.getElementById('brandExcelFileFrame');
				iframe.src = baseurl+"/pat/exportSpecialPatents.html";
				listenExcelLoading();
			} else if (data == "2") {
				$(".viptip-title").html("抱歉，您暂时无法使用导出功能！");
				$(".viptip-content").html("龙图腾高级会员享有导出清单的权益，您可以选择以下方式成为高级会员：");
				$(".exportTipModalBtn").click();
			} else {
				// $("#myForm").attr("action", baseurl+"/loginForm.html");
				// $("#myForm").submit();
				isLoginModalFlag()
			}
		}
	});
}

// 复制文本
$(document).on("click", ".copy-item",function(){
	var text = $(this).attr("data-value")
	var curPatentId = $(this).attr("data-pid-copy")
	var curInput = document.getElementById('pidcheck' + curPatentId)
	var tr = curInput.parentNode.parentNode.parentNode.parentNode.parentNode
	curInput.checked = true
	if (curInput.checked) {
		tr.style.background = '#F2F2F2'
	} else {
		tr.style.background = ''
	}

	if ($(this).hasClass("copy-desc")) {
		var arr = text.split(',');
		var copyValue = "";
		//例：未下证 发明 2020115131468 一种金属纱网成卷清理保护方法  二级会员价:13500  说明:恢复截止时间20221010
		copyValue += arr[0] + " " + arr[1] + " " + arr[2] + " " + arr[3];
		if (arr[4] != arr[5] && parseInt(arr[4]) > 0) {
			copyValue += " 高级GIP会员价:" + arr[4];
		} else if (Math.abs(parseInt(arr[5])) > 0) {
			copyValue += " 转让价:" + Math.abs(parseInt(arr[5]));
		}
		if (arr[6] != "") {
			copyValue += " 说明:" + arr[6];
			if (arr[7] != "") {
				copyValue += "，" + arr[7];
			}
		} else if (arr[7] != "") {
			copyValue += " 说明:" + arr[7];
		}
		text = copyValue;
	} else if ($(this).hasClass("copy-price-desc")) {
		var arr = text.split(',');
		var copyValue = "";
		//例：未下证 发明 2021100274228 一种防划伤的药品提取装置 二级(或者一级)会员价:11000  说明:截止时间20230727-不提供发明人证件   2023-07-27发明专利第3年年费135
		copyValue += arr[0] + " " + arr[1] + " " + arr[2] + " " + arr[3] + " " + arr[4];
		var saleRemark = $(this).attr("data-saleRemark");
		var description = $(this).attr("data-description");
		if (saleRemark != "") {
			copyValue += " 说明:" + saleRemark;
			if (description != "") {
				copyValue += "，" + description;
			}
		} else if (description != "") {
			copyValue += " 说明:" + description;
		}
		if (arr[5] != "") {
			copyValue += " " + arr[5] + arr[6] + arr[7];
		}
		text = copyValue;
	}
	var input = document.createElement("input"); // 直接构建input
	input.style.opacity = 0
	input.setAttribute("readonly", "readonly"); //设置只读，否则移动端会有键盘弹出
	input.value = text; // 设置内容
	document.body.appendChild(input); // 添加临时实例
	input.select(); // 选择实例内容
	document.execCommand("Copy"); // 执行复制
	document.body.removeChild(input); // 删除临时实例
	dialog.tipsPop('','提示','已复制好，可贴粘。');
	setTimeout(function() {
		$(".ui-dialog-close").click()
	},1000);
	var itemCheckbox = document.getElementsByName('patentid') //子项
	var allCheckbox = document.getElementById('allChecked') // 全选

	for (var i = 0; i < itemCheckbox.length; i++) {
		if (!itemCheckbox[i].checked) { // 当有一个未选
			allCheckbox.checked = false
			return
		}
		allCheckbox.checked = true
	}
});

//下载说明书
function downloadFile(appNo,patentId){
	$("#downloadAppNo").val(appNo);
	$("#downloadPatentId").val(patentId);
	$("#downloadForm").attr("action", baseurl+"/patent/searchPatentPdf.html");
	$("#downloadForm").submit();
	/*$.ajax({
		url: baseurl+"/pat/getMongodbPatent.html",
		type: 'post',
		cache : false,
		async:false,
		data: {"appNo":appNo,"patentId":patentId},
		success: function(data) {
			var item = JSON.parse(data);
			if(item.mongoPatent == null){
				$("#downloadAppNo").val(appNo);
				$("#fileName").val(item.fileName);
				$("#downloadForm").attr("action", "https://file.lotut.vip:9991/file/downloadUploadFile");
				$("#downloadForm").submit();
			}else{
				$("#downloadAppNo").val(item.mongoPatent.appNo);
				$("#patentType").val(item.mongoPatent.patentTypeStr);
				$("#patentPublishDate").val(item.mongoPatent.publishDateStr);
				$("#fileName").val(item.fileName);
				$("#downloadForm").attr("action", "https://file.lotut.vip:9991/file/searchDownload");
				$("#downloadForm").submit();
			}
		}
	});*/
};

// 加载微信二维码
function loadWxQrCodedImg () {
	$('.public_user--qrcode .img img:first-child').hide()
	$('.public_user--qrcode .img img:last-child').show()
	$('.public_user--qrcode .img').css('background', '#FFF')
}

// 联系卖家
function contactPublishUser(patentId, price, insideCustomerName) {
	$(".publishUserBody>p>span").html("");
	$.ajax({
		url: baseurl+"/patent/contactPublishUser.do",
		type: 'post',
		dataType: 'json',
		cache: false,
		data: {"patentId":patentId,"price":price, "insideCustomerName":insideCustomerName},
		success: function(res) {
			if (res.code == 0) {
				$('.public_user--qrcode .img img:first-child').attr('src', '')
				var publishUser = res.data;
				clickconcatpub.peoplemsg = publishUser
				clickconcatpub.peoplemsg.patentId = patentId
				clickconcatpub.peoplemsg.isSelfSupport = publishUser.isSelfSupport
				clickconcatpub.getExpends()
				$(".publishUserModalBtn").click();
			} else if (res.code == 300) {
				// $("#myForm").attr("action", baseurl+"/loginForm.html");
				// $("#myForm").submit();
				isLoginModalFlag()
			} else {
				dialog.tipsPop('','提示', res.msg ,function(){});
			}
		},
		error: function(res) {
			dialog.tipsPop('','提示','请刷新页面重新操作',function(){});
		}
	});
}

//申请下架
function soldOut(patentId){
	$.ajax({
        url: baseurl+"/patent/applySoldOut.do",
        type: 'post',
        dataType: 'json',
        cache: false,
        data: {"patentId":patentId},
        success: function(res) {
            if (res.code == 0) {
            	dialog.tipsPop('','提示',"申请成功，请等待审核结果！" ,function(){});
            } else {
                dialog.tipsPop('','提示', res.msg ,function(){});
            }
        },
        error: function(res) {
            dialog.tipsPop('','提示','请刷新页面重新操作',function(){});
        }
    });
}

// 弹窗确认关注
function sureFollowByModal() {
	var uniquefriendNos = [];
	var checks = document.getElementsByName("share-friend-item");
	for (var i = 0;i<checks.length;i++) {
		if(checks[i].checked){
			uniquefriendNos.push(checks[i].value);
		}
	}
	var friends = uniquefriendNos.join(",");
	if (uniquefriendNos == ''){
		dialog.tipsPop('','提示','请选择客户！',function(){});
	} else {
		var patentId = $("#patentId").val();
		$.ajax({ // 请求添加关注
			url: baseurl+"/pat/followPatentByCustomer.html",
			type: 'post',
			data: {'patentId': patentId, 'friendId' : friends},
			dataType: 'json',
			cache: false,
			success: function (res) {
				closeShowFriendModal();
				// ! 请求成功后才执行操作
				if (res.code == 0) {
					// ! 添加关注请求成功（需要修改 数据库 & 当前 实例的数据）
					var dtoList = res.data.dtoList;
					var tablelist = vum.tableData;
					tablelist.forEach(function(item,index){
						dtoList.forEach(function(pitem,pindex){
							if(pitem.patentId == item.patentId){
								vum.tableData[index].userFollowFlag = dtoList[pindex].userFollowFlag
								vum.tableData[index].followCount = dtoList[pindex].followCount
							}
						})
					})
					// # 处理“我的关注数”
					$(".follow-count").html(res.data.allFollowCount);
					if (dtoList.length > 0) {
						successMessageTips(vum,'批量关注成功！')
					}
				} else { // 否则需要登录
					// $("#myForm").attr("action", baseurl+"/loginForm.html");
					// $("#myForm").submit();
					isLoginModalFlag()
				}
			},
			error: function (data) {
				dialog.tipsPop('', '提示', '请刷新页面重新操作', function () {
				})

			}
		});
	}
}

//获取交易均价
function initTransactionAvgPrice() {
	$.ajax({
		url: baseurl+"/pat/initTransactionAvgPrice.html",
		type: 'get',
		dataType: 'json',
		success: function(data) {
			$(".fmsq_val").html(data[0]['price']);
		},
		error: function() {

		}
	});
}
//加载交易均价
initTransactionAvgPrice();

// 加载建议售价
function editGoodRecommendPrice(patentId,sellType,patentType,appNo,patentName,patentNamePureText) {
	$.ajax({
		url: baseurl+"/pat/loadGoodRecommendPrice.html",
		type: 'get',
		data: {'patentId' : patentId},
		dataType: 'json',
		cache: false,
		success: function(res) {
			if (res.code == 0) {
				var val = res.data == null || res.data == 0? '' : res.data;
				var sellTypeText='<span class="'+(sellType==1?'re_no_certificate':(sellType==2?'re_has_certificate':''))+'">'+(sellType==1?'未下证':(sellType=2?'已下证':''))+'</span>';
				var patentTypeText='';
				if (patentType==1) {
					patentTypeText='<span class="td0">发明</span>';
				} else if (patentType==2) {
					patentTypeText='<span class="td1">实用</span>';
				} else if (patentType==3) {
					patentTypeText='<span class="td2">外观</span>';
				}
				var appNoText='<span>'+appNo+'</span>';
				var content='<div class="recommend-price-div"><div>'+sellTypeText+patentTypeText+appNoText+'</div>'
					+'<p title="'+patentNamePureText+'">'+patentName+'</p>'
					+'<p style="">售价/元：<input type="number" value="'+val+'" min="0" max="9999999" id="recommendPriceVal" class="recommend-price-input" onkeyup="this.value=this.value.replace(/\s+e/g,\'\')"/></p>'
					+'</div>';
				dialog.tipsPopConfirm('建议采购',content,function(){
					var recommendPriceVal = parseInt($('#recommendPriceVal').val());
					if (recommendPriceVal > 9999999) {
						dialog.tipsPop('','提示', '价格太大了，请输入小于10000000的整数',function(){});
						return;
					}
					if (recommendPriceVal > 0) {
						saveGoodRecommendPrice(patentId, recommendPriceVal);
					} else {
						dialog.tipsPop('','提示', '请填写大于0的整数',function(){});
					}
				},function(){},'保存','关闭');
			} else {
				dialog.tipsPop('','提示', '登录信息已失效，请刷新页面重新登录。',function(){});
			}
		},
		error: function() {
			dialog.tipsPop('', '提示', '请刷新页面重新操作', function () {});
		}
	});
}

// 保存专利建议售价
function saveGoodRecommendPrice(patentId, price) {
	$.ajax({
		url: baseurl+"/pat/saveGoodRecommendPrice.html",
		type: 'post',
		dataType: 'json',
		cache: false,
		data: {"patentId":patentId, "recommendPrice":price},
		success: function(res) {
			if (res.code == 0) {
				dialog.tipsPop('', '提示', '保存成功！')
				setTimeout(function() {
					$(".ui-dialog-close").click()
				},1500);
			} else {
				dialog.tipsPop('','提示', '登录信息已失效，请刷新页面重新登录。',function(){});
			}
		},
		error: function(res) {
			dialog.tipsPop('','提示','请刷新页面重新操作',function(){});
		}
	});
}

//批量关注
function followSelectedPatents(e) {
	var dataId = $(e).attr('data-id');
	if (dataId == -1) {
		isLoginModalFlag();
		return;
	}
	// 获取选中项的值
	var obj = document.getElementsByName('patentid');
	var curPatentId = []
	for(var i = 0; i < obj.length; i++) {
		if(obj[i].checked) {
			curPatentId.push(obj[i].value)
		}
	}
	// 提示选中不能为空
	if (curPatentId.length === 0) {
		dialog.tipsPop('', '提示', '请选择专利！')
		setTimeout(function() {
			$(".ui-dialog-close").click()
		},1000);
		return;
	}
	// 选中项不为空时（转为字符串）
	curPatentId = curPatentId.join(',');
	if (dataId == 1) {
		$("#patentId").val(curPatentId);
		loadFollowFriends(null,0);
	} else {
		$.ajax({ // 请求添加关注
			url: baseurl+"/pat/batchFollowPatent.html",
			type: 'post',
			data: {'patentId': curPatentId},
			dataType: 'json',
			cache: false,
			success: function (res) {
				// ! 请求成功后才执行操作
				if (res.code == 0) {
					successMessageTips(vum,'批量关注成功！')
					// ! 添加关注请求成功（需要修改 数据库 & 当前 实例的数据）
					var dtoList = res.data.dtoList;
					var tablelist = vum.tableData;
					tablelist.forEach(function(item,index){
						dtoList.forEach(function(pitem,pindex){
							if(pitem.patentId == item.patentId){
								vum.tableData[index].userFollowFlag = dtoList[pindex].userFollowFlag
								vum.tableData[index].followCount = dtoList[pindex].followCount
							}
						})
					})
					// # 处理“我的关注数”
					$(".follow-count").html(res.data.allFollowCount);
				} else { // 否则需要登录
					// $("#myForm").attr("action", baseurl+"/loginForm.html");
					// $("#myForm").submit();
					isLoginModalFlag()
				}
			},
			error: function (data) {
				dialog.tipsPop('', '提示', '请刷新页面重新操作', function () {
				})

			}
		});
	}
}
